Subject: Re: What's cooking in git.git (Aug 2025, #02; Mon, 4)

From: Junio C Hamano <[email-masked]>
Date: Thu, 07 Aug 2025 08:22:23 -0700

Patrick Steinhardt <[email-masked]> writes:

> On Wed, Aug 06, 2025 at 02:18:34PM -0700, Junio C Hamano wrote:
>> SZEDER Gábor <[email-masked]> writes:
>> 
>> > Before merging please make sure that the topic can be built on its
>> > own.  Currently all of its commits, including the merge commit the
>> > topic is based on, fail to build because:
>> >
>> >   $ git log --oneline -1
>> >   fc33fe7eff (HEAD) Merge branch 'ps/reflog-migrate-fixes' into ps/remote-rename-fix
>> >   $ make
>> >       CC builtin/reflog.o
>> >   builtin/reflog.c:7:10: fatal error: object-store.h: No such file or directory
>> >       7 | #include "object-store.h"
>> >         |          ^~~~~~~~~~~~~~~~
>> >   compilation terminated.
>> >   make: *** [Makefile:2817: builtin/reflog.o] Error 1
>> 
>> The joy of having too many moving parts X-<.
>> 
>> Thanks for catching.
>
> I guess what I learned is that I'll refrain from building on top of a
> topic that hasn't hit "next" yet from now on. I knew it was a going to
> become a bit painful, but I guess it's even more so than I expected.

As long as the base topic is reasonably stable, having to recreate
the base merge(s---there have been cases where a topic depended on
multiple in-flight topics) and rebasing the existing dependign topic
on top of the updated base was not _too_ painful.  In addition to
rerere, I use machinery to remember and reuse necessary semantic
conflict resolution that was done once (which is used to rebuild
'seen' on top of 'master' a few times every day).

In this particular case, it was me being absent-minded without
realizing the base merge may need merge fixes until SZEDER pointed
out.

Thanks.